%UPORABA UMETNIH NEVRONSKIH MRE ZA OCENO TRDNOSTI LESENIH ELEMENTOV
%Avtor:Nataa inkovec
%Diplomsko delo,2008,UL,Fakulteta za gradbenitvo in geodezijo,Konstrukcijska smer

Podatki;
data=vrednosti(:,1:3);
data=data';

out=vrednosti(:,4)';

[data_norm,data_par]=mapminmax(data); %normiranje podatkov
[out_norm,out_par]=mapminmax(out);

net = newcf(minmax(data_norm),[3 4 4 1],{'tansig' 'tansig' 'tansig' 'tansig'});
net=init(net);

net.adaptParam.passes = 100; %tevilo maksimalnih iteracij

dim=max(size(data));
P = mat2cell(data_norm,[3],repmat(1,dim,1));
T = mat2cell(out_norm,[1],repmat(1,dim,1));
[net,y,e,pf,af,tr]=adapt(net,P,T); %adaptivno uenje mree 
mse(cell2mat(e))
cell2mat(e)'
size(find(abs(cell2mat(e))>0.25))%absolutna razlika med dejanskimi in z mreo izraunanimi izhodnimi vrednostmi


Podatki_testni;
data1=testne_vrednosti(:,1:3); % vhodni podatki
data1=data1';
out1=testne_vrednosti(:,4)'; %izhodne vrednosti


data1_1=zeros(3,196);
data1_1(:,1:43)=data1;
data_norm1 = mapminmax('apply',data1_1,data_par);

out1_1=zeros(1,196);
out1_1(1:43)=out1;
out_norm1=mapminmax('apply',out1_1,out_par); %normiranje rezultatov

kaj_meni_mreza_norm=sim(net,data_norm1(:,1:43)); %simulacija mree na testnih podatkih
kaj_meni_mreza_norm_1=zeros(1,196);
kaj_meni_mreza_norm_1(1:43)=kaj_meni_mreza_norm;

kaj_meni_mreza=mapminmax('reverse',kaj_meni_mreza_norm_1,out_par);
kaj_meni_mreza_1=kaj_meni_mreza(1:43);



figure(2);

[m,b,r]=postreg(kaj_meni_mreza_1,out1);
set(gcf,'Name','Linearna regresija rezultatov glede na vrednosti');


napaka1=(kaj_meni_mreza_1-out1);
napaka1=napaka1';

srednja_vrednost_napake = sum(napaka1)/size(napaka1,1)
srednja_absolutna_napaka = sum(abs(napaka1-srednja_vrednost_napake))/size(napaka1,1)
standardno_odstopanje_srednjega_kvadrata_razlike = sqrt(sum((napaka1-srednja_vrednost_napake).^2)/size(napaka1,1))

srednja_vrednost_izhodnega_podatka=sum(out1)/size(out1,2);
srednja_vrednost_izracunanega_podatka=sum(kaj_meni_mreza_1)/size(kaj_meni_mreza_1,2);

kovarianca=sum((out1-srednja_vrednost_izhodnega_podatka).*(kaj_meni_mreza_1-srednja_vrednost_izracunanega_podatka))./size(out1,2);
std_dev_X=sqrt(sum((out1-srednja_vrednost_izhodnega_podatka).^2)./size(out1,2));
std_dev_Y=sqrt(sum((kaj_meni_mreza_1-srednja_vrednost_izracunanega_podatka).^2)./size(out1,2));

koeficient_koleracije=kovarianca/(std_dev_X*std_dev_Y)


